##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
# 
# frozen_string_literal: true

module Twilio
  module REST
    class Authy
      class V1 < Version
        ##
        # Initialize the V1 version of Authy
        def initialize(domain)
          super
          @version = 'v1'
          @services = nil
          @forms = nil
        end

        ##
        # @param [String] sid A 34 character string that uniquely identifies this Service.
        # @return [Twilio::REST::Authy::V1::ServiceContext] if sid was passed.
        # @return [Twilio::REST::Authy::V1::ServiceList]
        def services(sid=:unset)
          if sid.nil?
            raise ArgumentError, 'sid cannot be nil'
          elsif sid == :unset
            @services ||= ServiceList.new self
          else
            ServiceContext.new(self, sid)
          end
        end

        ##
        # @param [form.FormTypes] form_type The Type of this Form. One of `form-app-push`,
        #   `form-sms` or `form-totp`.
        # @return [Twilio::REST::Authy::V1::FormContext] if form_type was passed.
        # @return [Twilio::REST::Authy::V1::FormList]
        def forms(form_type=:unset)
          if form_type.nil?
            raise ArgumentError, 'form_type cannot be nil'
          elsif form_type == :unset
            @forms ||= FormList.new self
          else
            FormContext.new(self, form_type)
          end
        end

        ##
        # Provide a user friendly representation
        def to_s
          '<Twilio::REST::Authy::V1>'
        end
      end
    end
  end
end