##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
# 
# frozen_string_literal: true

module Twilio
  module REST
    class Verify < Domain
      ##
      # Initialize the Verify Domain
      def initialize(twilio)
        super

        @base_url = 'https://verify.twilio.com'
        @host = 'verify.twilio.com'
        @port = 443

        # Versions
        @v2 = nil
      end

      ##
      # Version v2 of verify
      def v2
        @v2 ||= V2.new self
      end

      ##
      # @param [String] sid The unique string that we created to identify the Service
      #   resource.
      # @return [Twilio::REST::Verify::V2::ServiceInstance] if sid was passed.
      # @return [Twilio::REST::Verify::V2::ServiceList]
      def services(sid=:unset)
        self.v2.services(sid)
      end

      ##
      # Provide a user friendly representation
      def to_s
        '#<Twilio::REST::Verify>'
      end
    end
  end
end