##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
# 
# frozen_string_literal: true

require 'spec_helper.rb'

describe 'Webhook' do
  it "can fetch" do
    @holodeck.mock(Twilio::Response.new(500, ''))

    expect {
      @client.messaging.v1.webhooks().fetch()
    }.to raise_exception(Twilio::REST::TwilioError)

    values = {}
    expect(
    @holodeck.has_request?(Holodeck::Request.new(
        method: 'get',
        url: 'https://messaging.twilio.com/v1/Sessions/Webhooks',
    ))).to eq(true)
  end

  it "receives fetch responses" do
    @holodeck.mock(Twilio::Response.new(
        200,
      %q[
      {
          "account_sid": "ACaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
          "service_sid": "ISaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
          "pre_webhook_url": "http://pre.url",
          "post_webhook_url": "http://post.url",
          "webhook_method": "GET",
          "webhook_filters": [
              "onMessageSend",
              "onSessionAdded"
          ],
          "pre_webhook_retry_count": 1,
          "post_webhook_retry_count": 2,
          "target": "http",
          "url": "https://messaging.twilio.com/v1/Sessions/Webhooks"
      }
      ]
    ))

    actual = @client.messaging.v1.webhooks().fetch()

    expect(actual).to_not eq(nil)
  end

  it "can update" do
    @holodeck.mock(Twilio::Response.new(500, ''))

    expect {
      @client.messaging.v1.webhooks().update()
    }.to raise_exception(Twilio::REST::TwilioError)

    values = {}
    expect(
    @holodeck.has_request?(Holodeck::Request.new(
        method: 'post',
        url: 'https://messaging.twilio.com/v1/Sessions/Webhooks',
    ))).to eq(true)
  end

  it "receives update responses" do
    @holodeck.mock(Twilio::Response.new(
        200,
      %q[
      {
          "account_sid": "ACaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
          "service_sid": "ISaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
          "pre_webhook_url": "http://pre.url",
          "post_webhook_url": "http://post.url",
          "webhook_method": "GET",
          "webhook_filters": [
              "onSessionAdded"
          ],
          "pre_webhook_retry_count": 1,
          "post_webhook_retry_count": 2,
          "target": "flex",
          "url": "https://messaging.twilio.com/v1/Sessions/Webhooks"
      }
      ]
    ))

    actual = @client.messaging.v1.webhooks().update()

    expect(actual).to_not eq(nil)
  end
end