##
# This code was generated by
# \ / _    _  _|   _  _
#  | (_)\/(_)(_|\/| |(/_  v1.0.0
#       /       /
# 
# frozen_string_literal: true

require 'spec_helper.rb'

describe 'BulkCountryUpdate' do
  it "can create" do
    @holodeck.mock(Twilio::Response.new(500, ''))

    expect {
      @client.voice.v1.dialing_permissions \
                      .bulk_country_updates.create(update_request: 'update_request')
    }.to raise_exception(Twilio::REST::TwilioError)

    values = {'UpdateRequest' => 'update_request', }
    expect(
    @holodeck.has_request?(Holodeck::Request.new(
        method: 'post',
        url: 'https://voice.twilio.com/v1/DialingPermissions/BulkCountryUpdates',
        data: values,
    ))).to eq(true)
  end

  it "receives create responses" do
    @holodeck.mock(Twilio::Response.new(
        201,
      %q[
      {
          "update_count": 1,
          "update_request": "accepted"
      }
      ]
    ))

    actual = @client.voice.v1.dialing_permissions \
                             .bulk_country_updates.create(update_request: 'update_request')

    expect(actual).to_not eq(nil)
  end
end